﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data.Linq.Mapping;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using Dades;
using Negoci;

namespace WcfService
{    
    [ServiceContract]
    public interface IService
    {
        [OperationContract]
        string GetData(int value);     

        [OperationContract]
        bool ValidarAcces(string user, string password);

        [OperationContract]
        List<Seccions> LlistaSeccions();

        [OperationContract]
        List<Consumicions> LlistaConsumicions();

        [OperationContract]
        List<Consumicions> LlistaPrimers();

        [OperationContract]
        List<Consumicions> LlistaSegons();

        [OperationContract]
        List<Consumicions> LlistaPostres();

        [OperationContract]
        List<Consumicions> LlistaBegudes();

        [OperationContract]
        List<Ofertes> LlistaOfertes();

        [OperationContract]
        List<Reserves> LlistaReserves();

        [OperationContract]
        Consumicions ConsultarConsumicio(string nom);

        [OperationContract]
        Ofertes ConsultarOferta(string id);

        [OperationContract]
        Menus ConsultarMenu(string nom);

        [OperationContract]
        Reserves ConsultarReserva(int id);

        [OperationContract]
        Client_Registrat ConsultarClient(int DNI);

        [OperationContract]
        void AfegirConsumicio(string nomCatala, string nomCastella, string nomAngles, string seccio, int comensals, float preu, string comentaris);

        [OperationContract]
        void EsborrarConsumicio(string nomCatala);

        [OperationContract]
        void ActualitzarConsumicio(string nomCatala);

        [OperationContract]
        void EsborrarMenu(string nom);

        [OperationContract]
        void EsborrarReserva(int id);
        
        [OperationContract]
        void ActualitzarReserva(int id, string comentaris);
        
        [OperationContract]
        void EsborrarOferta(string id);

        [OperationContract]
        List<Menus> LlistaMenus();

        [OperationContract]
        List<Consumicio_Seccio_Menu> LlistaPrimersMenu(string nomMenu);

        [OperationContract]
        List<Consumicio_Seccio_Menu> LlistaSegonsMenu(string nomMenu);

        [OperationContract]
        List<Consumicio_Seccio_Menu> LlistaPostresMenu(string nomMenu);

        [OperationContract]
        List<Consumicio_Seccio_Menu> LlistaBegudesMenu(string nomMenu);

        [OperationContract]
        List<Client_Registrat> LlistaClients();

        [OperationContract]
        List<Client_Registrat> LlistaClientsOferta(string idOferta);

        [OperationContract]
        void AfegirMenu(string nom, float preu, bool incIVA, bool incBeguda, int comensals, string descripcio,
                                List<String> primers, List<String> segons, List<String> postres, List<String> begudes);

        [OperationContract]
        Boolean AfegirReserva(DateTime data, TimeSpan hora, int comensals, string comentaris, string nom, string cognom, string telefon, string correu);

        [OperationContract]
        void AfegirOferta(string id, string descripcio, List<string> clients);
    }
}
