﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data.Linq.Mapping;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using Negoci;
using Dades;
using System.Windows.Forms;

namespace WcfService
{    
    public class Service : IService
    {
        public string GetData(int value)
        {
            return string.Format("You entered: {0}", value);
        }

        public bool ValidarAcces(string user, string password)
        {
            Negoci.Validacio usuari = new Negoci.Validacio();
            return usuari.ValidarAcces(user, password);
        }

        public List<Seccions> LlistaSeccions()
        {
            Negoci.Consumicio con = new Negoci.Consumicio();
            return con.LlistaSeccions();
        }

        public List<Consumicions> LlistaConsumicions()
        {
            Negoci.Consumicio con = new Negoci.Consumicio();
            return con.LlistaConsumicions();
        }

        public List<Consumicions> LlistaPrimers()
        {
            Negoci.Consumicio con = new Negoci.Consumicio();
            return con.LlistaPrimers();
        }

        public List<Consumicions> LlistaSegons()
        {
            Negoci.Consumicio con = new Negoci.Consumicio();
            return con.LlistaSegons();
        }

        public List<Consumicions> LlistaPostres()
        {
            Negoci.Consumicio con = new Negoci.Consumicio();
            return con.LlistaPostres();
        }

        public List<Consumicions> LlistaBegudes()
        {
            Negoci.Consumicio con = new Negoci.Consumicio();
            return con.LlistaBegudes();
        }

        public List<Ofertes> LlistaOfertes()
        {
            Negoci.Oferta of = new Negoci.Oferta();
            return of.LlistaOfertes();
        }

        public List<Reserves> LlistaReserves()
        {
            Negoci.Reserva res = new Negoci.Reserva();
            return res.LlistaReserves();
        }

        public List<Menus> LlistaMenus()
        {
            Negoci.Menu m = new Negoci.Menu();
            return m.LlistaMenus();
        }

        public List<Consumicio_Seccio_Menu> LlistaPrimersMenu(string nom)
        {
            Negoci.Menu m = new Negoci.Menu();
            return m.LlistaPrimersMenu(nom);
        }

        public List<Consumicio_Seccio_Menu> LlistaSegonsMenu(string nom)
        {
            Negoci.Menu m = new Negoci.Menu();
            return m.LlistaSegonsMenu(nom);
        }

        public List<Consumicio_Seccio_Menu> LlistaPostresMenu(string nom)
        {
            Negoci.Menu m = new Negoci.Menu();
            return m.LlistaPostresMenu(nom);
        }

        public List<Consumicio_Seccio_Menu> LlistaBegudesMenu(string nom)
        {
            Negoci.Menu m = new Negoci.Menu();
            return m.LlistaBegudesMenu(nom);
        }

        public List<Client_Registrat> LlistaClients()
        {
            Negoci.Client c = new Negoci.Client();
            return c.LlistaClients();
        }

        public List<Client_Registrat> LlistaClientsOferta(string idOferta)
        {
            Negoci.Client c = new Negoci.Client();
            return c.LlistaClientsOferta(idOferta);
        }

        public Consumicions ConsultarConsumicio(string nom)
        {
            Negoci.Consumicio con = new Negoci.Consumicio();
            return con.GetConsumicio(nom);   
        }

        public Ofertes ConsultarOferta(string id)
        {
            Negoci.Oferta of = new Negoci.Oferta();
            return of.GetOferta(id);
        }

        public Reserves ConsultarReserva(int id)
        {
            Negoci.Reserva res = new Negoci.Reserva();
            return res.GetReserva(id);
        }
        
        public Menus ConsultarMenu(string nom)
        {
            Negoci.Menu m = new Negoci.Menu();
            return m.GetMenu(nom);
        }

        public Client_Registrat ConsultarClient(int DNI)
        {
            Negoci.Client c = new Negoci.Client();
            return c.GetClient(DNI);
        }

        public void AfegirConsumicio(string nomCatala, string nomCastella, string nomAngles, string seccio, int comensals, float preu, string comentaris)
        {
            Negoci.Consumicio con = new Negoci.Consumicio();         
            con.AfegirConsumicio(nomCatala, nomCastella, nomAngles, seccio, comensals, preu, comentaris);
        }

        public Boolean AfegirReserva(DateTime data, TimeSpan hora, int comensals, string comentaris, string nom, string cognom, string telefon, string correu)
        {
            Negoci.Reserva res = new Negoci.Reserva();
            return res.AfegirReserva(data, hora, comensals, comentaris, nom, cognom, telefon, correu);
        }
        
        public void ActualitzarReserva(int id, string comentaris)
        {
            Negoci.Reserva res = new Negoci.Reserva();
            res.ActualitzarReserva(id, comentaris);
        }
        
        public void EsborrarConsumicio(string nomCatala)
        {
            Negoci.Consumicio con = new Negoci.Consumicio();           
            con.EsborrarConsumicio(nomCatala);      
        }

        public void ActualitzarConsumicio(string nomCatala)
        {
            Negoci.Consumicio con = new Negoci.Consumicio();
            con.ActualitzarConsumicio(nomCatala);
        }

        public void EsborrarMenu(string nom)
        {
            Negoci.Menu menu = new Negoci.Menu();        
            menu.EsborrarMenu(nom);       
        }

        public void EsborrarReserva(int id)
        {
            Negoci.Reserva res = new Negoci.Reserva();        
            res.EsborrarReserva(id);        
        }

        public void EsborrarOferta(string id)
        {
            Negoci.Oferta of = new Negoci.Oferta();         
            of.EsborrarOferta(id);         
        } 

        public void AfegirMenu(string nom, float preu, bool incIVA, bool incBeguda, int comensals, string descripcio,
                         List<String> primers, List<String> segons, List<String> postres, List<String> begudes)
        {
            Negoci.Menu m = new Negoci.Menu();
            m.AfegirMenu(nom, preu, incIVA, incBeguda, comensals, descripcio, primers, segons, postres, begudes);
        }

        public void AfegirOferta(string id, string descripcio, List<string> clients)
        {
            Negoci.Oferta of = new Negoci.Oferta();
            of.AfegirOferta(id, descripcio, clients);
        }        
    }
}
