﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Dades;

using System.Net;
using System.Net.Mail;
using System.Net.Mime; 


namespace WpfPresentacio
{
    /// <summary>
    /// Lógica de interacción para Principal.xaml
    /// </summary>
    public partial class Principal : Window
    {
        private Ofertes consultaOferta;

        public Principal()
        {
            InitializeComponent();

            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

            //Carreguem els combos amb les dades.
            this.carregarComboSeccio();

            this.carregarComboNom();

            this.carregarComboSeccioC();

            this.carregarComboPrimers();

            this.carregarComboPrimersC();

            this.carregarComboSegons();

            this.carregarComboSegonsC();

            this.carregarComboPostres();

            this.carregarComboPostresC();

            this.carregarComboBegudes();

            this.carregarComboBegudesC();

            this.carregarComboMenu();

            this.carregarComboHores();            

            carregarComboDies();

            carregarComboNumeroMenu();

            //Carreguem els listbox amb les dades.
            this.carregarListBoxOfertes();

            this.carregarListBoxReserves();

            this.carregarListBoxClients();

            //Configurem els Datepicker per tal que comencin a partir del dia present
            DateTime avui = new DateTime();

            avui = DateTime.Today;

            dpReserva.DisplayDateStart = avui;

            dpReservaC.DisplayDateStart = avui;     
           
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) { }

        # region Carrega de dades

        private void carregarComboSeccio()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboSeccio.DisplayMemberPath = "nomSeccio";
            comboSeccio.SelectedValuePath = "nomSeccio";
            comboSeccio.ItemsSource = proxy.LlistaSeccions();
        }

        private void carregarComboNom()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboNom.DisplayMemberPath = "nomConsumicioCatala";
            comboNom.SelectedValuePath = "nomConsumicioCatala";
            comboNom.ItemsSource = proxy.LlistaConsumicions();
        }

        private void carregarComboSeccioC()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboSeccioConsulta.DisplayMemberPath = "nomSeccio";
            comboSeccioConsulta.SelectedValuePath = "nomSeccio";
            comboSeccioConsulta.ItemsSource = proxy.LlistaSeccions();
        }

        private void carregarListBoxOfertes()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            lbOfertes.DisplayMemberPath = "idOferta";
            lbOfertes.SelectedValuePath = "idOferta";
            lbOfertes.ItemsSource = proxy.LlistaOfertes();
        }

        private void carregarListBoxReserves()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();           
            listBoxReserves.ItemsSource = proxy.LlistaReserves();
            listBoxReserves.SelectedIndex = -1;      
        }

        private void carregarListBoxClients()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            listBoxClients.ItemsSource = proxy.LlistaClients();
            listBoxClientsC.ItemsSource = proxy.LlistaClients();
        }

        private void carregarComboPrimers()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboPrimers.DisplayMemberPath = "nomConsumicioCatala";
            comboPrimers.SelectedValuePath = "nomConsumicioCatala";
            comboPrimers.ItemsSource = proxy.LlistaPrimers();
        }

        private void carregarComboPrimersC()
        {  
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboPrimersC.DisplayMemberPath = "nomConsumicioCatala";
            comboPrimersC.SelectedValuePath = "nomConsumicioCatala";
            comboPrimersC.ItemsSource = proxy.LlistaPrimers();
        }

        private void carregarComboSegons()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboSegons.DisplayMemberPath = "nomConsumicioCatala";
            comboSegons.SelectedValuePath = "nomConsumicioCatala";
            comboSegons.ItemsSource = proxy.LlistaSegons();
        }

        private void carregarComboSegonsC()
        {   
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboSegonsC.DisplayMemberPath = "nomConsumicioCatala";
            comboSegonsC.SelectedValuePath = "nomConsumicioCatala";
            comboSegonsC.ItemsSource = proxy.LlistaSegons();
        }

        private void carregarComboPostres()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboPostres.DisplayMemberPath = "nomConsumicioCatala";
            comboPostres.SelectedValuePath = "nomConsumicioCatala";
            comboPostres.ItemsSource = proxy.LlistaPostres();
        }

        private void carregarComboPostresC()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboPostresC.DisplayMemberPath = "nomConsumicioCatala";
            comboPostresC.SelectedValuePath = "nomConsumicioCatala";
            comboPostresC.ItemsSource = proxy.LlistaPostres();
        }

        private void carregarComboBegudes()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboBegudes.DisplayMemberPath = "nomConsumicioCatala";
            comboBegudes.SelectedValuePath = "nomConsumicioCatala";
            comboBegudes.ItemsSource = proxy.LlistaBegudes();
        }

        private void carregarComboBegudesC()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboBegudesC.DisplayMemberPath = "nomConsumicioCatala";
            comboBegudesC.SelectedValuePath = "nomConsumicioCatala";
            comboBegudesC.ItemsSource = proxy.LlistaBegudes();
        }

        private void carregarComboMenu()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            comboNomMenu.DisplayMemberPath = "nomMenu";
            comboNomMenu.SelectedValuePath = "nomMenu";
            comboNomMenu.ItemsSource = proxy.LlistaMenus();
        }

        private void carregarComboDies()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();         
            
            cbDies.Items.Clear();
            
            cbDies.Items.Add("Dilluns");
            cbDies.Items.Add("Dimarts");
            cbDies.Items.Add("Dimecres");
            cbDies.Items.Add("Dijous");
            cbDies.Items.Add("Divendres");
            cbDies.Items.Add("Dissabte");
            cbDies.Items.Add("Diumenge");

            foreach (Menus m in proxy.LlistaMenus())
            {
                if (m.nomMenu.Equals("Monday")) cbDies.Items.Remove("Dilluns");
                if (m.nomMenu.Equals("Tuesday")) cbDies.Items.Remove("Dimarts");
                if (m.nomMenu.Equals("Wednesday")) cbDies.Items.Remove("Dimecres");
                if (m.nomMenu.Equals("Thursday")) cbDies.Items.Remove("Dijous");
                if (m.nomMenu.Equals("Friday")) cbDies.Items.Remove("Divendres");
                if (m.nomMenu.Equals("Saturday")) cbDies.Items.Remove("Dissabte");
                if (m.nomMenu.Equals("Sunday")) cbDies.Items.Remove("Diumenge");
            }
        }

        private void carregarComboNumeroMenu()
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();          
         
            cbMenu.Items.Clear();

            cbMenu.Items.Add("Menú 1");
            cbMenu.Items.Add("Menú 2");
            cbMenu.Items.Add("Menú 3");
            cbMenu.Items.Add("Menú 4");
            cbMenu.Items.Add("Menú 5");
            cbMenu.Items.Add("Menú 6");
            cbMenu.Items.Add("Menú 7");
            cbMenu.Items.Add("Menú 8");
            cbMenu.Items.Add("Menú 9");
            cbMenu.Items.Add("Menú 10");

            foreach (Menus m in proxy.LlistaMenus())
            {
                cbMenu.Items.Remove(m.nomMenu);             
            }
        }
        
        private void carregarComboHores()
        {
            TimeSpan[] hores = new TimeSpan[12];
            TimeSpan iniciMigdia = new TimeSpan(13, 0, 0);
            TimeSpan iniciNit = new TimeSpan(20, 30, 0);
            TimeSpan interval = new TimeSpan(0, 30, 0);

            int i = 0;
            while (iniciMigdia < new TimeSpan(16, 00, 0))
            {
                hores[i] = iniciMigdia;
                i++;
                iniciMigdia = iniciMigdia + interval;
            }

            int j = 0;
            while (iniciNit < new TimeSpan(23, 30, 0))
            {
                hores[i + j] = iniciNit;
                j++;
                iniciNit = iniciNit + interval;
            }

            comboHores.ItemsSource = hores;
            comboHores.ItemStringFormat = "t";
            comboHoresC.ItemsSource = hores;            
        }
        
        # endregion

        # region Consumicions

        // Esdeveniment resultat de clicar al botó guardar consumició.
        private void botoAltaConsumicio_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

                // Si l'usuari no omple tots els camps obligatoris, es mostra el missatge adient.
                if (comboSeccio.SelectedItem == null || tbNomConsumicioCatala.Text.Equals("") || tbComensals.Text.Equals("") || tbPreu.Text.Equals(""))
                {                    
                    throw new Exception("Si us plau, omple tots els camps obligatoris");
                }
                             
                    int comensals = int.Parse(tbComensals.Text);
                    
                    // Si el nombre de comensals introduït no és correcte, es mostra el missatge adient.
                    if (comensals < 1 || comensals > 4)
                    {
                        throw new Exception("El nombre de comensals de la reserva ha de ser un valor comprès entre 1 i 4");                       
                    }

                    float preu = float.Parse(tbPreu.Text);

                    // Si el preu introduït no és correcte, es mostra el missatge adient.
                    if (preu == 0 || preu > 99999)
                    {
                        throw new Exception("El preu ha d'estar comprès entre 0 i 99999");
                    }

                    // Mirem si existeix a la BD una comsumició amb aquest nom
                    Consumicions consulta = proxy.ConsultarConsumicio(tbNomConsumicioCatala.Text);
                    
                    // Si ja existeix una, mostrem el missatge adient.
                    if (consulta != null)
                    {
                        throw new Exception("Ja existeix una consumició amb aquest nom");                        
                    }           
                 
                    // Guardem la comanda al sistema
                    proxy.AfegirConsumicio(tbNomConsumicioCatala.Text, tbNomConsumicioCastella.Text, tbNomConsumicioAngles.Text,
                                    comboSeccio.SelectedValue.ToString(), int.Parse(tbComensals.Text), float.Parse(tbPreu.Text), tbDescripcio.Text);

                    MessageBox.Show("S'ha afegit la consumició", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);

                    // Actualitzem les dades de l'aplicació.
                    carregarComboNom();
                    carregarComboPrimers();
                    carregarComboPrimersC();
                    carregarComboSegons();
                    carregarComboSegonsC();
                    carregarComboPostres();
                    carregarComboPostresC();
                    carregarComboBegudes();
                    carregarComboBegudesC();
              
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Exclamation); }            
        }

        // Mètode que gestiona el canvi del combo amb els noms de les consumicions
        private void comboNom_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

                Consumicions consulta = proxy.ConsultarConsumicio((String)comboNom.SelectedValue);                

                if (consulta != null)
                {
                    nomCastella.Text = consulta.nomConsumicioCastella;

                    nomAngles.Text = consulta.nomConsumicioAngles;

                    tbComensalsConsulta.Text = consulta.minComensals.ToString();

                    comboSeccioConsulta.Text = consulta.nomSeccio;

                    tbDescripcioConsulta.Text = consulta.descripcio;

                    tbPreuC.Text = consulta.preu.ToString();
                }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Exclamation); }
        }

        // Mètode que permet actualitzar els canvis introduïts a una comanda.
        private void btActualitzarConsumicio_Click(object sender, RoutedEventArgs e)
        {
            try
            {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

            // Si la consulta no hi és a la BD o no hem seleccionat res.
            if (comboNom.SelectedIndex == -1) { throw new Exception("Si us plau, seleccioni una consumició"); }

            Consumicions consulta = proxy.ConsultarConsumicio((String)comboNom.SelectedValue);

            // Demanem confirmació a l'usuari:
            MessageBoxResult resposta = MessageBox.Show("Vol actualitzar els canvis a: " + consulta.nomConsumicioCatala+"?", "Confirmació", MessageBoxButton.OKCancel, MessageBoxImage.Question);
                    
            // Si l'usuari vol actualitzar
            if (resposta == MessageBoxResult.OK)
            {
                 // Si l'usuari no ha introduït totes les dades obligatòries.
                if (comboSeccioConsulta.SelectedItem == null || tbComensalsConsulta.Text.Equals("") || tbPreuC.Text.Equals(""))
                 {
                     throw new Exception("Si us plau, omple tots els camps requerits");                       
                 }

                 int comensals = int.Parse(tbComensalsConsulta.Text);

                 // Si el nombre de comensals introduït no és correcte, es mostra el missatge adient.
                 if (comensals < 1 || comensals > 4)
                 {
                     throw new Exception("El nombre de comensals de la reserva ha de ser un valor comprès entre 1 i 4");
                 }

                 float preu = float.Parse(tbPreuC.Text);

                 // Si el preu introduït no és correcte, es mostra el missatge adient.
                 if (preu == 0 || preu > 999)
                 {
                     throw new Exception("El preu ha d'estar comprès entre 0 i 99999");
                 }
                        
                 // L'usuari ha introduït totes les dades obligatòries.
                 proxy.ActualitzarConsumicio(consulta.nomConsumicioCatala);

                 // Afegim la nova consumició amb els canvis.
                 proxy.AfegirConsumicio(comboNom.SelectedValue.ToString(), nomCastella.Text, nomAngles.Text, comboSeccioConsulta.SelectedValue.ToString(),
                                                    int.Parse(tbComensalsConsulta.Text), float.Parse(tbPreuC.Text), tbDescripcioConsulta.Text);
                                                                                    
                 comboNom.SelectedIndex = -1;

                 comboSeccioConsulta.SelectedIndex = -1;

                 NetejarConsultaConsumicio();

                 MessageBox.Show("Consumició modificada", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);

                 carregarComboPrimers();
                 carregarComboPrimersC();
                 carregarComboSegons();
                 carregarComboSegonsC();
                 carregarComboPostres();
                 carregarComboPostresC();
                 carregarComboBegudes();
                 carregarComboBegudesC();    
            }               
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Exclamation); }
        }

        // Mètode que esborra les dades dels camps d'una nova consumició.
        private void NetejarNovaConsumicio()
        {
            tbNomConsumicioCatala.Text = String.Empty;
            tbNomConsumicioCastella.Text = String.Empty;
            tbNomConsumicioAngles.Text = String.Empty;
            comboSeccio.SelectedIndex = -1;
            tbComensals.Text = String.Empty;
            tbPreu.Text = String.Empty;
            tbDescripcio.Text = String.Empty;
        }

        // Mètode que esborra les dades dels camps d'una consulta.
        private void NetejarConsultaConsumicio()
        {
            nomCastella.Text = String.Empty;
            nomAngles.Text = String.Empty;
            comboSeccioConsulta.SelectedIndex = -1;
            tbComensalsConsulta.Text = String.Empty;
            tbPreuC.Text = String.Empty;
            tbDescripcioConsulta.Text = String.Empty;
        }

        // Mètode que gestiona l'esdeveniment produït en clicar al botó cancel·lar. 
        private void NetejarConsumicio_Click(object sender, RoutedEventArgs e)
        {
            NetejarNovaConsumicio();
        }

        // Mètode que gestiona l'esdeveniment produït en clicar al botó cancel·lar.
        private void NetejarConsultaConsumicio_Click(object sender, RoutedEventArgs e)
        {
            NetejarConsultaConsumicio();
        }

        // Mètode que gestiona l'esdeveniment produït en clicar al botó d'esborrar consumició.
        private void botoEsborrarConsumicio_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

                // Si no hem seleccionat la consumició a esborrar.
                if (comboNom.SelectedIndex == -1) { throw new Exception("Si us plau, seleccioni una consumició a esborrar"); }

                Consumicions consulta = proxy.ConsultarConsumicio((String)comboNom.SelectedValue);

                // Si hi ha una consumició a la BD
                if (consulta != null)
                {
                    // construim un missatge per advertir de la baixa del client i si volem continuar
                    MessageBoxResult resposta = MessageBox.Show("Vol esborrar la consumició: " + consulta.nomConsumicioCatala, "Confirmar", MessageBoxButton.OKCancel);

                    if (resposta == MessageBoxResult.OK)
                    {
                        // Esborrem la consumició de la BD.
                        proxy.EsborrarConsumicio(consulta.nomConsumicioCatala);

                        // Netegem els camps.
                        NetejarConsultaConsumicio();

                        // Tornem a carregar els combos.
                        carregarComboNom();
                        carregarComboPrimers();
                        carregarComboPrimersC();
                        carregarComboSegons();
                        carregarComboSegonsC();
                        carregarComboPostres();
                        carregarComboPostresC();
                        carregarComboBegudes();
                        carregarComboBegudesC();

                        MessageBox.Show("Consumicio esborrada", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);
                    }
                }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        # endregion

        # region Menus


        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del combo amb els primers.
        private void comboPrimer_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

                // Mirem si ja havíem afegit la consumició seleccionada al listbox
                bool consulta = ExisteixComanda(listBoxPrimers, (String)comboPrimers.SelectedValue);

                // Si no l'havíem afegit, ho fem.
                if (!consulta)
                {
                    listBoxPrimers.Items.Add((String)comboPrimers.SelectedValue);//prova
                }
            }
            catch (Exception ex) {MessageBox.Show(ex.Message, "Error!!", MessageBoxButton.OK, MessageBoxImage.Error);}
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del combo amb els primers.
        private void comboPrimersC_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

            // Mirem si ja havíem afegit la consumició
            bool consulta = ExisteixComanda(listBoxPrimersC, (String)comboPrimersC.SelectedValue);

            // Si no l'havíem afegit, ho fem.
            if (!consulta)
            {                               
                listBoxPrimersC.Items.Add((String)comboPrimersC.SelectedValue);//prova      
            }        
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del combo amb els segons.
        private void comboSegon_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

            // Mirem si ja havíem afegit la consumició seleccionada al listbox
            bool consulta = ExisteixComanda(listBoxSegons, (String)comboSegons.SelectedValue);

            // Si no l'havíem afegit, ho fem.
            if (!consulta)
            {
                listBoxSegons.Items.Add((String)comboSegons.SelectedValue);//prova
            }
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del combo amb els segons.
        private void comboSegonsC_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

            // Mirem si ja havíem afegit la consumició
            bool consulta = ExisteixComanda(listBoxSegonsC, (String)comboSegonsC.SelectedValue);

            // Si no l'havíem afegit, ho fem.
            if (!consulta)
            {
                listBoxSegonsC.Items.Add((String)comboSegonsC.SelectedValue);//prova      
            }   
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del combo amb els postres.
        private void comboPostres_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

            // Mirem si ja havíem afegit la consumició seleccionada al listbox
            bool consulta = ExisteixComanda(listBoxPostres, (String)comboPostres.SelectedValue);

            // Si no l'havíem afegit, ho fem.
            if (!consulta)
            {
                listBoxPostres.Items.Add((String)comboPostres.SelectedValue);//prova
            }
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del combo amb els postres.
        private void comboPostresC_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();            

            // Mirem si ja havíem afegit la consumició
            bool consulta = ExisteixComanda(listBoxPostresC, (String)comboPostresC.SelectedValue);

            // Si no l'havíem afegit, ho fem.
            if (!consulta)
            {
                listBoxPostresC.Items.Add((String)comboPostresC.SelectedValue);//prova      
            }   
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del combo amb les begudes.
        private void comboBegudes_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

            // Mirem si ja havíem afegit la consumició seleccionada al listbox
            bool consulta = ExisteixComanda(listBoxBegudes, (String)comboBegudes.SelectedValue);

            // Si no l'havíem afegit, ho fem.
            if (!consulta)
            {
                listBoxBegudes.Items.Add((String)comboBegudes.SelectedValue);//prova
            }
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del combo amb les begudes.
        private void comboBegudesC_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

            // Mirem si ja havíem afegit la consumició
            bool consulta = ExisteixComanda(listBoxBegudesC, (String)comboBegudesC.SelectedValue);

            // Si no l'havíem afegit, ho fem.
            if (!consulta)
            {
                listBoxBegudesC.Items.Add((String)comboBegudesC.SelectedValue);//prova      
            } 
        }

        // Mètode que permet saber si ja existeix una determinada comanda a un listbox.
        private bool ExisteixComanda(ListBox listbox, string nomConsumicio)
        {
            if (listbox.Items.Contains(nomConsumicio)) return true;
            else return false;
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció al listbox amb els primers.
        private void listBoxPrimers_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // S'esborra la comanda seleccionada
            if (listBoxPrimers.SelectedIndex != -1) listBoxPrimers.Items.Remove(listBoxPrimers.SelectedItem);
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció al listbox amb els segons.
        private void listBoxSegons_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // S'esborra la comanda seleccionada
            if (listBoxSegons.SelectedIndex != -1) listBoxSegons.Items.Remove(listBoxSegons.SelectedItem);
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció al listbox amb els postres.
        private void listBoxPostres_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // S'esborra la comanda seleccionada
            if (listBoxPostres.SelectedIndex != -1) listBoxPostres.Items.Remove(listBoxPostres.SelectedItem);
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció al listbox amb les begudes.
        private void listBoxBegudes_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // S'esborra la comanda seleccionada
            if (listBoxBegudes.SelectedIndex != -1) listBoxBegudes.Items.Remove(listBoxBegudes.SelectedItem);
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció al listbox amb els primers.
        private void listBoxPrimersC_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // S'esborra la comanda seleccionada
            if (listBoxPrimersC.SelectedIndex != -1) listBoxPrimersC.Items.Remove(listBoxPrimersC.SelectedItem);
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció al listbox amb els segons.
        private void listBoxSegonsC_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // S'esborra la comanda seleccionada
            if (listBoxSegonsC.SelectedIndex != -1) listBoxSegonsC.Items.Remove(listBoxSegonsC.SelectedItem);
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció al listbox amb els postres.
        private void listBoxPostresC_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // S'esborra la comanda seleccionada
            if (listBoxPostresC.SelectedIndex != -1) listBoxPostresC.Items.Remove(listBoxPostresC.SelectedItem);
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció al listbox amb les begudes.
        private void listBoxBegudesC_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // S'esborra la comanda seleccionada
            if (listBoxBegudesC.SelectedIndex != -1) listBoxBegudesC.Items.Remove(listBoxBegudesC.SelectedItem);
        }

        // Mètode que permet guardar un menú a la BD
        private void botoGuardarMenu_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

                // Si l'usuari no omple tots els camps obligatoris, es mostra el missatge adient.
                if (tbNomMenu.Text.Equals("") || tbComensalsMenu.Text.Equals("") || tbPreuMenu.Text.Equals(""))
                {
                    throw new Exception("Si us plau, omple tots els camps obligatoris");
                }

                // Si l'usuari ha introduït totes les dades obligatòries.

                int comensals = int.Parse(tbComensalsMenu.Text);

                // Si el nombre de comensals introduït no és correcte, es mostra el missatge adient.
                if (comensals < 1 || comensals > 4)
                {
                    throw new Exception("El nombre de comensals ha de ser un valor comprès entre 1 i 4");
                }

                float preu = float.Parse(tbPreuMenu.Text);

                // Si el preu introduït no és correcte, es mostra el missatge adient.
                if (preu == 0 || preu > 999)
                {
                    throw new Exception("El preu ha d'estar comprès entre 0 i 99999");
                }

                // Recollim la composició de les seccions del menú.
                List<String> llistaPrimers = new List<String>();
                List<String> llistaSegons = new List<String>();
                List<String> llistaPostres = new List<String>();
                List<String> llistaBegudes = new List<String>();

                foreach (String c in listBoxPrimers.Items)
                {
                    llistaPrimers.Add(c);
                }

                foreach (String c in listBoxSegons.Items)
                {
                    llistaSegons.Add(c);
                }

                foreach (String c in listBoxPostres.Items)
                {
                    llistaPostres.Add(c);
                }

                foreach (String c in listBoxBegudes.Items)
                {
                    llistaBegudes.Add(c);
                }

                cbDies.SelectedIndex = -1;

                cbMenu.SelectedIndex = -1;

                proxy.AfegirMenu(tbNomMenu.Text, float.Parse(tbPreuMenu.Text), (bool)checkBoxIVA.IsChecked, (bool)checkBoxBeguda.IsChecked, int.Parse(tbComensalsMenu.Text), tbDescripcioMenu.Text,
                                   llistaPrimers.ToArray(), llistaSegons.ToArray(), llistaPostres.ToArray(), llistaBegudes.ToArray());
                
                this.tbNomMenu.Text = "";
                
                this.NetejarNouMenu();           
                
                MessageBox.Show("S'ha afegit el menú", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);

                carregarComboMenu();
                carregarComboDies();
                carregarComboNumeroMenu();
            }    
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }            
        }

        private void botoGuardarMenuC_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

                // Si la consulta no hi és a la BD o no hem seleccionat res.
                if (comboNomMenu.SelectedIndex == -1) { throw new Exception("Si us plau, seleccioni un menú"); }

                // Si l'usuari no omple tots els camps obligatoris, es mostra el missatge adient.
                if ( tbComensalsMenuC.Text.Equals("") || tbPreuMenuC.Text.Equals(""))
                {
                    throw new Exception("Si us plau, omple tots els camps obligatoris");
                }

                // Si l'usuari ha introduït totes les dades obligatòries.

                int comensals = int.Parse(tbComensalsMenuC.Text);

                // Si el nombre de comensals introduït no és correcte, es mostra el missatge adient.
                if (comensals < 1 || comensals > 4)
                {
                    throw new Exception("El nombre de comensals ha de ser un valor comprès entre 1 i 4");
                }

                float preu = float.Parse(tbPreuMenuC.Text);

                // Si el preu introduït no és correcte, es mostra el missatge adient.
                if (preu == 0 || preu > 99999)
                {
                    throw new Exception("El preu ha d'estar comprès entre 0 i 99999");
                }

                // Mirem si el menú existeix a la BD.
                Menus consulta = proxy.ConsultarMenu((String)comboNomMenu.SelectedValue);
                                
                // Si existeix
                if (consulta != null)
                {
                    // Demanem confirmació a l'usuari.
                    MessageBoxResult resposta = MessageBox.Show("Vol actualitzar els canvis al menú: " + consulta.nomMenu, "Confirmar", MessageBoxButton.OKCancel, MessageBoxImage.Question);

                    // Si l'usuari vol actualitzar.
                    if (resposta == MessageBoxResult.OK)
                    {
                        // Esborrem el menú de la BD
                        proxy.EsborrarMenu(consulta.nomMenu);
             
                            // Recollim la composició de les seccions del menú.
                            List<String> llistaPrimers = new List<String>();
                            List<String> llistaSegons = new List<String>();
                            List<String> llistaPostres = new List<String>();
                            List<String> llistaBegudes = new List<String>();

                            foreach (String c in listBoxPrimersC.Items)
                            {
                                llistaPrimers.Add(c);
                            }

                            foreach (String c in listBoxSegonsC.Items)
                            {
                                llistaSegons.Add(c);
                            }

                            foreach (String c in listBoxPostresC.Items)
                            {
                                llistaPostres.Add(c);
                            }

                            foreach (String c in listBoxBegudesC.Items)
                            {
                                llistaBegudes.Add(c);
                            }

                            proxy.AfegirMenu(comboNomMenu.SelectedValue.ToString(), float.Parse(tbPreuMenuC.Text), (bool)checkBoxIVAC.IsChecked,
                                                (bool)checkBoxBegudaC.IsChecked, int.Parse(tbComensalsMenuC.Text), tbDescripcioMenuC.Text,
                                                   llistaPrimers.ToArray(), llistaSegons.ToArray(), llistaPostres.ToArray(), llistaBegudes.ToArray());

                            MessageBox.Show("S'ha actualitzat el menú", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);
                        

                        // Tornem a carregar els combos amb els noms dels menús.
                        carregarComboMenu();

                        carregarComboNumeroMenu();

                        carregarComboDies();

                        NetejarConsultaMenu();
                    }
                }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        // Mètode que gestiona l'esdeveniment produït en clicar el botó d'esborrar menú. 
        private void botoEsborrarMenu_Click(object sender, RoutedEventArgs e)
        {
            try
            {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

            // Si no hem seleccionat el menú a esborrar.
            if (comboNomMenu.SelectedIndex == -1) { throw new Exception("Si us plau, seleccioni un menú a esborrar"); }

            // Mirem si el menú existeix a la BD.
            Menus consulta = proxy.ConsultarMenu((String)comboNomMenu.SelectedValue);

            // Si existeix
            if (consulta != null)
            {
                // Demanem confirmació a l'usuari.
                MessageBoxResult resposta = MessageBox.Show("Vol esborrar el menú: " + consulta.nomMenu, "Confirmar", MessageBoxButton.OKCancel, MessageBoxImage.Question);
                
                // Si l'usuari vol esborrar.
                if (resposta == MessageBoxResult.OK)
                {
                    // Esborrem el menú de la BD
                    proxy.EsborrarMenu(consulta.nomMenu);

                    // Netegem els camps
                    NetejarConsultaMenu();              

                    // Tornem a carregar el combo amb els noms dels menús.
                    carregarComboMenu();
                    carregarComboDies();
                    carregarComboNumeroMenu();
                    
                    // Informem del resultat
                    MessageBox.Show("Menú esborrat", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);
                }
            }
            
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del combo amb el nom del menú a consultar.
        private void comboNomMenu_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();
            
            // Consultem les dades del menú a la BD.
            Menus consulta = proxy.ConsultarMenu((String)comboNomMenu.SelectedValue);

            if (consulta !=null)
            {
                //Carreguem els diferents camps amb les dades obtingudes de la BD
                tbComensalsMenuC.Text = consulta.minComensals.ToString();

                tbPreuMenuC.Text = consulta.preu.ToString();

                checkBoxBegudaC.IsChecked = consulta.incBeguda;

                checkBoxIVAC.IsChecked = consulta.incIva;

                tbDescripcioMenuC.Text = consulta.descripcio;             
                
                //Netegem els listbox de les dades d'un altre menú.
                listBoxPrimersC.Items.Clear();
                listBoxSegonsC.Items.Clear();
                listBoxPostresC.Items.Clear();
                listBoxBegudesC.Items.Clear();                
                
                // Carreguem els listbox amb les consumicions
                foreach (Consumicio_Seccio_Menu c in proxy.LlistaPrimersMenu(consulta.nomMenu))
                {
                    listBoxPrimersC.Items.Add(c.nomConsumicioCatala);
                }

                foreach (Consumicio_Seccio_Menu c in proxy.LlistaSegonsMenu(consulta.nomMenu))
                {
                    listBoxSegonsC.Items.Add(c.nomConsumicioCatala);
                }

                foreach (Consumicio_Seccio_Menu c in proxy.LlistaPostresMenu(consulta.nomMenu))
                {
                    listBoxPostresC.Items.Add(c.nomConsumicioCatala);
                }

                foreach (Consumicio_Seccio_Menu c in proxy.LlistaBegudesMenu(consulta.nomMenu))
                {
                    listBoxBegudesC.Items.Add(c.nomConsumicioCatala);
                }                 
            }
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció al combo amb els tipus de menú.
        private void cbTipus_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // Si el tipus és Menú del dia.
            if (cbTipus.SelectedIndex == 0)
            {
                //S'habilita el combo per als dies.
                this.cbDies.IsEnabled = true;
                this.cbMenu.IsEnabled = false;
                this.tbNomMenu.IsEnabled = false; this.tbNomMenu.Text = "";
            }

            // Si és un menú per a qualsevol dia.
            else
            {
                //S'habilita el combo per als menús ordinaris.
                this.cbDies.IsEnabled = false;
                this.cbMenu.IsEnabled = true;
                this.tbNomMenu.IsEnabled = false; this.tbNomMenu.Text = "";
            }
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del combo amb els dies dels menús.
        private void cbDies_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {    
            if (this.cbDies.SelectedIndex != -1)
            {
                if (this.cbDies.SelectedValue.Equals("Dilluns")) this.tbNomMenu.Text = "Monday";
                if (this.cbDies.SelectedValue.Equals("Dimarts")) this.tbNomMenu.Text = "Tuesday";
                if (this.cbDies.SelectedValue.Equals("Dimecres")) this.tbNomMenu.Text = "Wednesday";
                if (this.cbDies.SelectedValue.Equals("Dijous")) this.tbNomMenu.Text = "Thursday";
                if (this.cbDies.SelectedValue.Equals("Divendres")) this.tbNomMenu.Text = "Friday";
                if (this.cbDies.SelectedValue.Equals("Dissabte")) this.tbNomMenu.Text = "Saturday";
                if (this.cbDies.SelectedValue.Equals("Diumenge")) this.tbNomMenu.Text = "Sunday";                
            }
        }

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del combo amb els menús ordinaris.
        private void cbMenu_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {           
            if (this.cbMenu.SelectedIndex !=-1)
            {
            this.tbNomMenu.Text = this.cbMenu.SelectedValue.ToString();

            }
        }

        // Mètode que gestiona l'esdeveniment produït en marcar el checkbox que indica que el menú inclou la beguda.
        private void checkBoxBeguda_Checked(object sender, RoutedEventArgs e)
        {
            comboBegudes.IsEnabled = true;
            listBoxBegudes.IsEnabled = true;
        }

        // Mètode que gestiona l'esdeveniment produït en desmarcar el checkbox que indica que el menú inclou la beguda.
        private void checkBoxBeguda_Unchecked(object sender, RoutedEventArgs e)
        {
            comboBegudes.IsEnabled = false;
            comboBegudes.SelectedIndex = -1;
            listBoxBegudesC.Items.Clear();
            listBoxBegudes.IsEnabled = false;
        }

        // Mètode que gestiona l'esdeveniment produït en marcar el checkbox que indica que el menú inclou la beguda a la consulta dels menús.
        private void checkBoxBegudaC_Checked(object sender, RoutedEventArgs e)
        {
            comboBegudesC.IsEnabled = true;
            listBoxBegudesC.IsEnabled = true;
        }

        // Mètode que gestiona l'esdeveniment produït en desmarcar el checkbox que indica que el menú inclou la beguda a la consulta dels menús.
        private void checkBoxBegudaC_Unchecked(object sender, RoutedEventArgs e)
        {
            comboBegudesC.IsEnabled = false;
            comboBegudesC.SelectedIndex = -1;
            listBoxBegudesC.Items.Clear();
            listBoxBegudesC.IsEnabled = false;
        }       

        //Mètode que gestiona l'esdevenimnet produït en clicar el boto de cancel·lar.
        private void botoNetejarMenu_Click(object sender, RoutedEventArgs e)
        {
            NetejarNouMenu();
        }

        //Mètode que gestiona l'esdevenimnet produït en clicar el boto de cancel·lar a consultar menú.
        private void botoNetejarMenuC_Click(object sender, RoutedEventArgs e)
        {
            NetejarConsultaMenu();
        }

        //Mètode que permet netejar els camps del menú.
        private void NetejarNouMenu()
        {
            tbComensalsMenu.Text = "";
            tbPreuMenu.Text = "";
            tbDescripcioMenu.Text = "";
            checkBoxIVA.IsChecked = false;
            checkBoxBeguda.IsChecked = false;
            comboPrimers.SelectedIndex = -1;
            comboSegons.SelectedIndex = -1;
            comboPostres.SelectedIndex = -1;
            comboBegudes.SelectedIndex = -1;
            listBoxPrimers.Items.Clear();
            listBoxSegons.Items.Clear();
            listBoxPostres.Items.Clear();
            listBoxBegudes.Items.Clear();
        }

        //Mètode que permet netejar els camps del menú consultat.
        private void NetejarConsultaMenu()
        {
            tbComensalsMenuC.Text = "";
            tbPreuMenuC.Text = "";
            tbDescripcioMenuC.Text = "";
            checkBoxIVAC.IsChecked = false;
            checkBoxBegudaC.IsChecked = false;
            comboPrimersC.SelectedIndex = -1;
            comboSegonsC.SelectedIndex = -1;
            comboPostresC.SelectedIndex = -1;
            comboBegudesC.SelectedIndex = -1;
            listBoxPrimersC.Items.Clear();
            listBoxSegonsC.Items.Clear();
            listBoxPostresC.Items.Clear();
            listBoxBegudesC.Items.Clear();
        }
        # endregion

        # region Reserves

        // Mètode que gestiona l'esdeveniment produït en clicar el botó de guardar reserva.
        private void botoGuardarReserva_Click(object sender, RoutedEventArgs e)
        {
            try
            { 
            WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

            Boolean resultat = false;

                          
                    // Si l'usuari no ha introduït tots els camps necessaris, avisem.
                    if (dpReserva.SelectedDate == null || comboHores.SelectedItem == null || tbComensalsReserva.Text.Equals("") ||
                                    tbNomReserva.Text.Equals("") || tbCognomReserva.Text.Equals("") || tbTelefonReserva.Text.Equals(""))
                    {
                        throw new Exception("Si us plau, omple tots els camps obligatoris");
                    }

                    // Si ho ha fet.
                    else
                    {                        
                        int comensals = int.Parse(tbComensalsReserva.Text);
                        // Si el nombre de comensals introduït no és correcte
                        if (comensals < 1 || int.Parse(tbComensalsReserva.Text) > 48)
                        {
                            throw new Exception("El nombre de comensals de la reserva ha de ser un valor comprès entre 1 i 48");
                        }
                        
                        // Si ho és
                        else
                        {

                            // Cridem al mètode afegir reserva que retorna un booleà en funció de si es pot fer la reserva o no.
                            resultat = proxy.AfegirReserva(DateTime.Parse(dpReserva.Text), TimeSpan.Parse(comboHores.SelectedValue.ToString()), int.Parse(tbComensalsReserva.Text),
                                            tbComentarisReserva.Text, tbNomReserva.Text, tbCognomReserva.Text, tbTelefonReserva.Text, tbCorreuReserva.Text);

                            // No s'ha pogut efectuar la reserva donat que no hi ha places suficients pel dia donat i l'hora donada.
                            if (resultat == false)
                            {
                                throw new Exception("No hi ha places, triï un altre horari");
                            }

                            // Si s'ha pogut enregistrar la reserva.
                            else
                            {
                                this.carregarListBoxReserves();
                                MessageBox.Show("Reserva efectuada", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);
                            }
                        }
                }
            }
            catch (FormatException) { MessageBox.Show("El nombre de comensals de la reserva ha de ser un valor comprès entre 1 i 48", "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        // Mètode que gestiona l'esdeveniment produït en clicar al botó de guardar una modificació d'una reserva.
        private void botoGuardarReservaC_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (listBoxReserves.SelectedIndex == -1) { throw new Exception("Si us plau, seleccioni una reserva"); }

                WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

                proxy.ActualitzarReserva(((Reserves)listBoxReserves.SelectedItem).idReserva, this.tbComentarisReservaC.Text);

                MessageBox.Show("Reserva modificada", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        // Mètode que gestiona l'esdeveniment produït en clicar al botó d'esborrar reserva.
        private void botoEsborrarReserva_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

                // Si l'usuari ha seleccionat una reserva a esborrar.
                if (listBoxReserves.SelectedValue != null)
                {
                    // Consultem les dades de la reserva            
                    Reserves consulta = proxy.ConsultarReserva(((Reserves)listBoxReserves.SelectedItem).idReserva);

                    // Informem per tal que l'usuari confirmi que vol esborrar.
                    MessageBoxResult resposta = MessageBox.Show("Vol esborrar la reserva: " + consulta.idReserva, "Confirmar", MessageBoxButton.OKCancel, MessageBoxImage.Question);

                    // Si l'usuari confirma:
                    if (resposta == MessageBoxResult.OK)
                    {
                        // Esborrem la reserva de la BD
                        proxy.EsborrarReserva(consulta.idReserva);

                        // Tornem a carregar el listbox amb les reserves
                        carregarListBoxReserves();

                        MessageBox.Show("Reserva esborrada", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);
                    }
                }
                // Si l'usuari no ha seleccionat cap reserva, s'informa l'usuari.
                else { throw new Exception("Seleccioni una reserva a esborrar"); }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        private void listBoxReserves_KeyUp(object sender, KeyEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient client = new WpfPresentacio.ServiceReference.ServiceClient();            
                
                Reserves consultaReserva = client.ConsultarReserva(((Reserves)listBoxReserves.SelectedItem).idReserva);
                
                if (consultaReserva != null)
                {
                    // Si la reserva no ha estat efectuada per un client registrat (telefònica presencial...)
                    if (consultaReserva.DNIClient.Equals(0))
                    {
                        gbContacteC.Opacity = 0;
                        MissatgeReserva.Opacity = 100;
                    }

                    // Si la reserva la va efectuar un client registrat via web.
                    else
                    {
                        gbContacteC.Opacity = 100;
                        MissatgeReserva.Opacity = 0;

                        Client_Registrat consultaClient = client.ConsultarClient(consultaReserva.DNIClient);

                        tbNomClientC.Text = consultaClient.nom;
                        tbCognomClientC.Text = consultaClient.cognom1;
                        tbTelefonClientC.Text = consultaClient.telefon.ToString();
                        tbCorreuClientC.Text = consultaClient.email;
                    }

                    // Carreguem els camps amb les dades de la reserva.
                    tbComentarisReservaC.Text = consultaReserva.comentaris;
                    dpReservaC.Text = consultaReserva.data.Date.ToString();
                    comboHoresC.SelectedValue = consultaReserva.hora;
                    tbComensalsReservaC.Text = consultaReserva.numComensals.ToString();
                }                
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        private void listBoxReserves_MouseEnter(object sender, MouseEventArgs e)
        {
            carregarListBoxReserves();
        }

        private void listBoxReserves_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            try
            {
                if (listBoxReserves.SelectedItem != null)
                {
                    WpfPresentacio.ServiceReference.ServiceClient client = new WpfPresentacio.ServiceReference.ServiceClient();

                    //  Reserves consultaReserva = client.ConsultarReserva((int)listBoxReserves.SelectedValue);
                    Reserves consultaReserva = client.ConsultarReserva(((Reserves)listBoxReserves.SelectedItem).idReserva);
                    if (consultaReserva != null)
                    {
                        // Si la reserva no ha estat efectuada per un client registrat (telefònica presencial...)
                        if (consultaReserva.DNIClient.Equals(0))
                        {
                            gbContacteC.Opacity = 0;
                            MissatgeReserva.Opacity = 100;
                        }
                        // Si la reserva la va efectuar un client registrat via web.
                        else
                        {
                            gbContacteC.Opacity = 100;
                            MissatgeReserva.Opacity = 0;

                            Client_Registrat consultaClient = client.ConsultarClient(consultaReserva.DNIClient);

                            tbNomClientC.Text = consultaClient.nom;
                            tbCognomClientC.Text = consultaClient.cognom1;
                            tbTelefonClientC.Text = consultaClient.telefon.ToString();
                            tbCorreuClientC.Text = consultaClient.email;
                        }

                        // Carreguem els camps amb les dades de la reserva.
                        tbComentarisReservaC.Text = consultaReserva.comentaris;
                        dpReservaC.Text = consultaReserva.data.Date.ToString();
                        comboHoresC.SelectedValue = consultaReserva.hora;
                        tbComensalsReservaC.Text = consultaReserva.numComensals.ToString();
                    }
                }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        private void listBoxReserves_KeyDown(object sender, KeyEventArgs e)
        {
            try
            {
            WpfPresentacio.ServiceReference.ServiceClient client = new WpfPresentacio.ServiceReference.ServiceClient();
           
                //  Reserves consultaReserva = client.ConsultarReserva((int)listBoxReserves.SelectedValue);
                Reserves consultaReserva = client.ConsultarReserva(((Reserves)listBoxReserves.SelectedItem).idReserva);
                if (consultaReserva != null)
                {
                    // Si la reserva no ha estat efectuada per un client registrat (telefònica presencial...)
                    if (consultaReserva.DNIClient.Equals(0))
                    {
                        gbContacteC.Opacity = 0;
                        MissatgeReserva.Opacity = 100;
                    }
                    // Si la reserva la va efectuar un client registrat via web.
                    else
                    {
                        gbContacteC.Opacity = 100;
                        MissatgeReserva.Opacity = 0;

                        Client_Registrat consultaClient = client.ConsultarClient(consultaReserva.DNIClient);

                        tbNomClientC.Text = consultaClient.nom;
                        tbCognomClientC.Text = consultaClient.cognom1;
                        tbTelefonClientC.Text = consultaClient.telefon.ToString();
                        tbCorreuClientC.Text = consultaClient.email;
                    }

                    // Carreguem els camps amb les dades de la reserva.
                    tbComentarisReservaC.Text = consultaReserva.comentaris;
                    dpReservaC.Text = consultaReserva.data.Date.ToString();
                    comboHoresC.SelectedValue = consultaReserva.hora;
                    tbComensalsReservaC.Text = consultaReserva.numComensals.ToString();
                }                
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        private void botoNetejarReserva_Click(object sender, RoutedEventArgs e)
        {
            NetejarNovaReserva();
        }

        //Mètode que gestiona l'esdevenimnet produït en clicar el boto de cancel·lar.
        private void botoNetejarReservaC_Click(object sender, RoutedEventArgs e)
        {
            NetejarConsultaReserva();
        }

        //Mètode que permet netejar els camps d'una reserva.
        private void NetejarNovaReserva()
        {
            dpReserva.SelectedDate = null;
            comboHores.SelectedIndex = -1;
            tbComensalsReserva.Text = "";
            tbNomReserva.Text = "";
            tbCognomReserva.Text = "";
            tbTelefonReserva.Text = "";
            tbCorreuReserva.Text = "";
            tbComentarisReserva.Text = "";
        }

        //Mètode que permet netejar els camps d'una reserva.
        private void NetejarConsultaReserva()
        {
            listBoxReserves.SelectedIndex = -1;
            dpReservaC.SelectedDate = null;
            comboHoresC.SelectedIndex = -1;
            tbComensalsReservaC.Text = "";
            tbComentarisReservaC.Text = "";
            gbContacteC.Opacity = 100;
            MissatgeReserva.Opacity = 0;
            tbNomClientC.Text = "";
            tbCognomClientC.Text = "";
            tbTelefonClientC.Text = "";
            tbCorreuClientC.Text = "";
        }

        # endregion

        # region ofertes

        // Mètode que gestiona l'esdeveniment produït en canviar la selecció del listbox
        private void lbOfertes_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient client = new WpfPresentacio.ServiceReference.ServiceClient();
                
                if (lbOfertes.SelectedIndex != -1)
                {
                    consultaOferta = client.ConsultarOferta(lbOfertes.SelectedValue.ToString());

                    if (consultaOferta != null)
                    {                       
                        tbDescripcioOfertaC.Text = consultaOferta.descripcio;
                        this.listBoxClientsTriatsC.Items.Clear();
                        foreach (Client_Registrat c in client.LlistaClientsOferta(lbOfertes.SelectedValue.ToString()))
                        {
                            foreach (Client_Registrat cc in listBoxClientsC.Items)
                            {
                                if (c.DNI.Equals(cc.DNI)) listBoxClientsTriatsC.Items.Add(cc);                                                        
                            }
                        }
                    }                    
                }
            }

            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        private bool ExisteixClient(ListBox listbox, Client_Registrat client)
        {
            if (listbox.Items.Contains((Client_Registrat)client)) return true;
            else return false;
        }

        private void afegirClient_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                // Mirem si ja havíem afegit la consumició seleccionada al listbox
                bool consulta = ExisteixClient(listBoxClientsTriats, (Client_Registrat)listBoxClients.SelectedItem);

                // Si no l'havíem afegit, ho fem.
                if (!consulta)
                {
                    listBoxClientsTriats.Items.Add(listBoxClients.SelectedItem); 
                }
            }

            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        private void treureClient_Click(object sender, RoutedEventArgs e)
        {
            listBoxClientsTriats.Items.Remove(listBoxClientsTriats.SelectedItem);
        }

        private void afegirTots_Click(object sender, RoutedEventArgs e)
        {
            listBoxClientsTriats.Items.Clear();
            foreach (Client_Registrat c in listBoxClients.Items) { listBoxClientsTriats.Items.Add(c); }
        }

        private void treureTots_Click(object sender, RoutedEventArgs e)
        {
            listBoxClientsTriats.Items.Clear();
        }

        private void botoAfegirClientC_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                // Mirem si ja havíem afegit la consumició seleccionada al listbox
                bool consulta = ExisteixClient(listBoxClientsTriatsC, (Client_Registrat)listBoxClientsC.SelectedItem);

                // Si no l'havíem afegit, ho fem.
                if (!consulta)
                {
                    listBoxClientsTriatsC.Items.Add(listBoxClientsC.SelectedItem);
                }
            }

            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        private void botoAfegirTotsC_Click(object sender, RoutedEventArgs e)
        {
            listBoxClientsTriatsC.Items.Clear();
            foreach (Client_Registrat c in listBoxClientsC.Items) { listBoxClientsTriatsC.Items.Add(c); }
        }

        private void botoTreureClientC_Click(object sender, RoutedEventArgs e)
        {
            listBoxClientsTriatsC.Items.Remove(listBoxClientsTriatsC.SelectedItem);
        }

        private void botoTreureTotsC_Click(object sender, RoutedEventArgs e)
        {
            listBoxClientsTriatsC.Items.Clear();
        }

        // Mètode que gestiona l'esdeveniment produït en clicar el botó de guardar i enviar reserva
        private void botoGuardarOferta_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

                // Si l'usuari no omple tots els camps obligatoris, es mostra el missatge adient.
                if (tbIdOferta.Text.Equals(""))
                {
                    throw new Exception("Si us plau, introdueix un identificador per l'oferta");
                }

                // Mirem si existeix a la BD una comsumició amb aquest nom
                Ofertes consulta = proxy.ConsultarOferta(tbIdOferta.Text);

                // Si ja existeix una, mostrem el missatge adient.
                if (consulta != null)
                {
                    throw new Exception("Ja existeix una reserva amb aquest nom");
                } 

                else
                {
                    List<string> clients = new List<string>();
                    foreach (Client_Registrat c in listBoxClientsTriats.Items) { clients.Add(c.DNI.ToString()); }

                    proxy.AfegirOferta(this.tbIdOferta.Text, this.tbDescripcioOferta.Text, clients.ToArray());

                    List<string> correus = new List<string>();

                    // Guardem a la llista de correus les adreces dels clients triats.
                    foreach (Client_Registrat c in listBoxClientsTriats.Items) { correus.Add(c.email); }

                    // Enviem el correu als destinataris
                    EnviarCorreuOferta(this.tbIdOferta.Text, this.tbDescripcioOferta.Text, correus);

                    this.carregarListBoxOfertes();

                    MessageBox.Show("S'ha guardat la oferta i s'han enviat els correus", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);
                }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        private void botoGuardarOfertaC_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient client = new WpfPresentacio.ServiceReference.ServiceClient();

                // Si la consulta no hi és a la BD o no hem seleccionat res.
                if (lbOfertes.SelectedIndex == -1) { throw new Exception("Si us plau, seleccioni una oferta"); }

                // Demanem confirmació a l'usuari.
                MessageBoxResult resposta = MessageBox.Show("Vol actualitzar la oferta: " + lbOfertes.SelectedValue.ToString(), "Confirmar", MessageBoxButton.OKCancel, MessageBoxImage.Question);

                // Si l'usuari vol guardar la oferta.
                if (resposta == MessageBoxResult.OK)
                {
                    List<string> clients = new List<string>();
                    foreach (Client_Registrat c in listBoxClientsTriatsC.Items) { clients.Add(c.DNI.ToString()); }

                    // Esborrem la oferta de la BD
                    client.EsborrarOferta(lbOfertes.SelectedValue.ToString());

                    client.AfegirOferta(lbOfertes.SelectedValue.ToString(), this.tbDescripcioOfertaC.Text, clients.ToArray());                    

                    List<string> correus = new List<string>();

                    // Guardem a la llista de correus les adreces dels clients triats.
                    foreach (Client_Registrat c in listBoxClientsTriatsC.Items) { correus.Add(c.email); }

                    // Enviem el correu als destinataris
                    EnviarCorreuOferta(lbOfertes.SelectedValue.ToString(), this.tbDescripcioOfertaC.Text, correus);

                    // Netegem els camps
                    NetejarOfertaC();

                    // Tornem a carregar el combo amb els noms dels menús.                    
                    carregarListBoxOfertes();

                    MessageBox.Show("S'ha actualitzat la oferta i s'han enviat els correus", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);
                }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning);}
        }

        // Mètode que permet enviar un correu electrònic amb una oferta a un conjunt de clients registrats.
        private void EnviarCorreuOferta(string id, string descripcio, List<string> correus)      
        {
            try
            {
                // Creem l'objecte missatge
                System.Net.Mail.MailMessage missatge = new System.Net.Mail.MailMessage();

                // Afegim els correus dels destinataris             
                foreach (string s in correus) { missatge.Bcc.Add(s); }

                // Els paràmetres d'enviament (remitent, nom a la safata d'entrada i codificació)
                missatge.From = new MailAddress("restaurantcanvictor@gmail.com", "Restaurant Can Victor", System.Text.Encoding.UTF8);

                // L'assumpte del correu
                missatge.Subject = "Tenim una nova oferta per tu: " + id;

                // Format de codificació de l'assumpte
                missatge.SubjectEncoding = System.Text.Encoding.UTF8;

                // El cos del correu contrindrà la descripció textual de l'oferta              
                missatge.Body = descripcio;

                // Format de codificació del cos.
                missatge.BodyEncoding = System.Text.Encoding.UTF8;

                // El cos no s'interpretarà com a codi HTMl
                missatge.IsBodyHtml = false;

                // Creem el client de correu especificant el nom i el port utilitzat
                SmtpClient client = new SmtpClient("smtp.gmail.com", 587);

                // Establim si la connexió és ssl
                client.EnableSsl = true;

                client.DeliveryMethod = SmtpDeliveryMethod.Network;

                // Hem d'establir les credencials d'autenticació per tal de poder fer l'enviament. Consten de l'adreça de la nostra adreça de correu i contrasenya. 
                client.UseDefaultCredentials = false;

                client.Credentials = new System.Net.NetworkCredential("restaurantcanvictor@gmail.com", "restaurantcanvictor1957");

                // Enviem el correu                
                client.Send(missatge);
            }
            catch (System.Net.Mail.SmtpException ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Exclamation); }            
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning);}
        }

        private void botoEsborrarOferta_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                WpfPresentacio.ServiceReference.ServiceClient proxy = new WpfPresentacio.ServiceReference.ServiceClient();

                // Si la consulta no hi és a la BD o no hem seleccionat res.
                if (lbOfertes.SelectedIndex == -1) { throw new Exception("Si us plau, seleccioni una oferta"); }

                // Mirem si l'oferta existeix a la BD.
                Ofertes consulta = proxy.ConsultarOferta(lbOfertes.SelectedValue.ToString());

                // Si existeix
                if (consulta != null)
                {
                    // Demanem confirmació a l'usuari.
                    MessageBoxResult resposta = MessageBox.Show("Vol esborrar la oferta: " + consulta.idOferta, "Confirmar", MessageBoxButton.OKCancel, MessageBoxImage.Question);

                    // Si l'usuari vol esborrar.
                    if (resposta == MessageBoxResult.OK)
                    {
                        // Esborrem el menú de la BD
                        proxy.EsborrarOferta(consulta.idOferta);

                        // Netegem els camps
                        NetejarOfertaC();

                        // Tornem a carregar el combo amb els noms dels menús.                    
                        carregarListBoxOfertes();

                        // Informem del resultat
                        MessageBox.Show("Oferta esborrada", "Informació", MessageBoxButton.OK, MessageBoxImage.Information);
                    }
                }

                // Si no existeix
                else { MessageBox.Show("Seleccioni una oferta a esborrar", "AVIS", MessageBoxButton.OK, MessageBoxImage.Information); }
            }

            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK, MessageBoxImage.Warning); }
        }

        //Mètode que gestiona l'esdeveniment produït en clicar el botó de cancel·lar.
        private void botoNetejarOferta_Click(object sender, RoutedEventArgs e)
        {
            NetejarNovaOferta();
        }

        //Mètode que gestiona l'esdeveniment produït en clicar el botó de cancel·lar.
        private void botoNetejarOfertaC_Click(object sender, RoutedEventArgs e)
        {
            NetejarOfertaC();
        }

        //Mètode que permet netejar els camps d'una nova oferta.
        private void NetejarNovaOferta()
        {
            tbIdOferta.Text = "";
            tbDescripcioOferta.Text = "";
            listBoxClientsTriats.Items.Clear();
        }

        //Mètode que permet netejar els camps d'una consulta d'una oferta.
        private void NetejarOfertaC()
        {
            lbOfertes.SelectedIndex = -1;
            tbDescripcioOfertaC.Text = "";
            listBoxClientsTriatsC.Items.Clear();
        }



        # endregion  

    }
}