﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Mòdul_Mòbil.ServiceReference;

namespace Mòdul_Mòbil
{
    public partial class IntrComensals : PhoneApplicationPage
    {
        Comanda comanda;

        public IntrComensals(Comanda c)
        {
            comanda = c;
            InitializeComponent();
            ServiceReference.ServiceClient proxy = new ServiceReference.ServiceClient();      
        }

        void proxy_GuardarComandaCompleted(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            MessageBox.Show("Comanda registrada", "Informació", MessageBoxButton.OK);

            //Passem la comanda com a paràmetre a la següent pàgina.
            App.Current.RootVisual = new AnotarComanda(comanda);
        }

        //Mètode de l'esdeveniment produït en clickar el botó de OK
        //Pregunta si es vol guardar la comanda i procedeix en conseqüència.
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                // Si l'usuari introdueix "0" per la taula, missatge d'error.
                if (int.Parse(this.tbComensals.Text) == 0)
                {
                    throw new Exception("Valor invàlid de la taula");
                }
                comanda.comensals = int.Parse(this.tbComensals.Text);
                MessageBoxResult resposta = MessageBox.Show("Vol enregistrar una comanda de la taula " + comanda.taula.ToString() + "?", "Atenció!!", MessageBoxButton.OKCancel);

                //Si l'usuari vol guardar la comanda
                if (resposta == MessageBoxResult.OK)
                {
                    ServiceReference.ServiceClient proxy = new ServiceReference.ServiceClient();

                    proxy.GuardarComandaCompleted += new EventHandler<System.ComponentModel.AsyncCompletedEventArgs>(proxy_GuardarComandaCompleted);

                    //Guarda la comanda a la BD
                    proxy.GuardarComandaAsync(comanda.taula, comanda.comensals, comanda.cambrer);
                }
                // Si no vol, passa la comanda com a paràmetre a la pàgina principal.
                else { App.Current.RootVisual = new MenuPrincipal(comanda); }
            }
            catch (FormatException) { MessageBox.Show("Si us plau, introdueixi un número >0", "Atenció!!", MessageBoxButton.OK); }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK); }
        }       
    }
}