﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Mòdul_Mòbil.ServiceReference;

namespace Mòdul_Mòbil
{
    public partial class IntrTaulaComanda : PhoneApplicationPage
    {
        Comanda comanda;

        public IntrTaulaComanda(Comanda c)
        {
            comanda = c;
            InitializeComponent();                        
        }

        void proxy_ConsultarTaulaCompleted(object sender, ConsultarTaulaCompletedEventArgs e)
        {
            // Si la taula ja té una comanda oberta.
            if (e.Result == false)
            {
                MessageBox.Show("La taula " + this.tbTaula.Text + " ja té una comanda oberta", "Atenció!!", MessageBoxButton.OKCancel);
                this.tbTaula.Text = "";
            }
            // Si no, naveguem a la pàgina següent passant l'identificador del cambrer i la taula com a paràmetres.
            else
            {
                comanda.taula = int.Parse(this.tbTaula.Text);
                App.Current.RootVisual = new IntrComensals(comanda);
            }
        }

        private void btOk_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                // Si l'usuari introdueix "0" per la taula, missatge d'error.
                if (int.Parse(this.tbTaula.Text) == 0)
                {
                    MessageBox.Show("Valor invàlid de la taula", "Error", MessageBoxButton.OK);
                }
                else
                {
                    ServiceReference.ServiceClient proxy = new ServiceReference.ServiceClient();
                    proxy.ConsultarTaulaCompleted += new EventHandler<ConsultarTaulaCompletedEventArgs>(proxy_ConsultarTaulaCompleted);
                    proxy.ConsultarTaulaAsync(int.Parse(this.tbTaula.Text));
                }
            }
            catch (FormatException) { MessageBox.Show("Si us plau, introdueixi un número >0", "Atenció!!", MessageBoxButton.OK); }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK); }
        }
    }
}
