﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Mòdul_Mòbil.ServiceReference;

namespace Mòdul_Mòbil
{
    public partial class IntrTaulaGestionar : PhoneApplicationPage
    {
        Comanda comanda;

        public IntrTaulaGestionar(Comanda c)
        {
            comanda = c; 
            InitializeComponent();
        }

        void proxy_ConsultarTaulaCompleted(object sender, ConsultarTaulaCompletedEventArgs e)
        {
            try
            {
                if (e.Result == true)
                {
                    MessageBox.Show("La taula " + this.tbTaula.Text + " No té una comanda oberta", "Atenció!!", MessageBoxButton.OK);
                    this.tbTaula.Text = "";
                }
                else
                {
                    comanda.taula = int.Parse(this.tbTaula.Text);
                    App.Current.RootVisual = new MenuGestio(comanda);
                }
            }
            catch (FormatException ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK); }
        }

        private void botoOk_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (this.tbTaula.Text == "0") throw new Exception("Valor invàlid de la taula");

                ServiceReference.ServiceClient proxy = new ServiceReference.ServiceClient();
                proxy.ConsultarTaulaCompleted += new EventHandler<ConsultarTaulaCompletedEventArgs>(proxy_ConsultarTaulaCompleted);
                proxy.ConsultarTaulaAsync(int.Parse(this.tbTaula.Text));
            }
            catch (FormatException) { MessageBox.Show("Si us plau, introdueixi un número >0", "Atenció!!", MessageBoxButton.OK); }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK); }
        }
    }
}
