﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Mòdul_Mòbil.ServiceReference;

namespace Mòdul_Mòbil
{
    public partial class MenuGestio : PhoneApplicationPage
    {
        Comanda comanda;
        public MenuGestio(Comanda c)
        {
            comanda = c;
            InitializeComponent();
        }

        private void botoConsultar_Click(object sender, RoutedEventArgs e)
        {
            App.Current.RootVisual = new AnotarComanda(comanda);
        }

        void proxy_TancarComandaCompleted(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            MessageBox.Show("Comanda tancada", "Informació", MessageBoxButton.OK);
        }

        private void botoTancar_Click(object sender, RoutedEventArgs e)
        {
            MessageBoxResult resposta = MessageBox.Show("Vol tancar la comanda de la taula "+comanda.taula+"?", "Atenció!!", MessageBoxButton.OKCancel);
            ServiceReference.ServiceClient proxy = new ServiceReference.ServiceClient();
            //Si l'usuari vol tancar la comanda
            if (resposta == MessageBoxResult.OK)
            {               
                //Esborra la comanda de la BD
                proxy.TancarComandaCompleted += new EventHandler<System.ComponentModel.AsyncCompletedEventArgs>(proxy_TancarComandaCompleted);
                
                proxy.TancarComandaAsync(comanda.taula);                
            }        
            
            //Tant si s'ha volgut tancar la comanda com si no, es retorna al menu principal
            App.Current.RootVisual = new MenuPrincipal(comanda);
        }
    }
}
