﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Mòdul_Mòbil.ServiceReference;


namespace Mòdul_Mòbil
{
    public partial class PivotPlats : PhoneApplicationPage
    {
        Comanda comanda;
        public PivotPlats(Comanda c)
        {
            comanda = c;

            InitializeComponent();
            ServiceReference.ServiceClient proxy = new ServiceReference.ServiceClient();

            # region Càrrega dels listbox
            // Carreguem els listbox de les comandes
            proxy.LlistaBegudesCompleted += new EventHandler<LlistaBegudesCompletedEventArgs>(proxy_LlistaBegudesCompleted);
            proxy.LlistaBegudesAsync();

            proxy.LlistaInfusionsCompleted += new EventHandler<LlistaInfusionsCompletedEventArgs>(proxy_LlistaInfusionsCompleted);
            proxy.LlistaInfusionsAsync();

            proxy.LlistaAmanidesCompleted += new EventHandler<LlistaAmanidesCompletedEventArgs>(proxy_LlistaAmanidesCompleted);
            proxy.LlistaAmanidesAsync();

            proxy.LlistaEntrantsCompleted += new EventHandler<LlistaEntrantsCompletedEventArgs>(proxy_LlistaEntrantsCompleted);
            proxy.LlistaEntrantsAsync();

            proxy.LlistaCarnsCompleted += new EventHandler<LlistaCarnsCompletedEventArgs>(proxy_LlistaCarnsCompleted);
            proxy.LlistaCarnsAsync();

            proxy.LlistaPeixosCompleted += new EventHandler<LlistaPeixosCompletedEventArgs>(proxy_LlistaPeixosCompleted);
            proxy.LlistaPeixosAsync();

            proxy.LlistaPastaCompleted += new EventHandler<LlistaPastaCompletedEventArgs>(proxy_LlistaPastaCompleted);
            proxy.LlistaPastaAsync();

            proxy.LlistaPostresCompleted += new EventHandler<LlistaPostresCompletedEventArgs>(proxy_LlistaPostresCompleted);
            proxy.LlistaPostresAsync();
            #endregion

            proxy.GuardarConsumicioComandaCompleted += new EventHandler<System.ComponentModel.AsyncCompletedEventArgs>(proxy_GuardarConsumicioComandaCompleted);
        }

        # region Gestors d'esdeveniments de càrrega dels listbox
        void proxy_LlistaBegudesCompleted(object sender, LlistaBegudesCompletedEventArgs e)
        {
            if (e != null) this.lbBegudes.ItemsSource = e.Result;                      
        }

        void proxy_LlistaInfusionsCompleted(object sender, LlistaInfusionsCompletedEventArgs e)
        {
            if (e != null) this.lbInfusions.ItemsSource = e.Result;
        }

        void proxy_LlistaAmanidesCompleted(object sender, LlistaAmanidesCompletedEventArgs e)
        {
            if (e != null)     this.lbAmanides.ItemsSource = e.Result;            
        }

        void proxy_LlistaEntrantsCompleted(object sender, LlistaEntrantsCompletedEventArgs e)
        {
            if (e != null) this.lbEntrants.ItemsSource = e.Result;                  
        }

        void proxy_LlistaCarnsCompleted(object sender, LlistaCarnsCompletedEventArgs e)
        {
            if (e != null) this.lbCarns.ItemsSource = e.Result;              
        }

        void proxy_LlistaPeixosCompleted(object sender, LlistaPeixosCompletedEventArgs e)
        {
            if (e != null) this.lbPeixos.ItemsSource = e.Result;               
        }

        void proxy_LlistaPastaCompleted(object sender, LlistaPastaCompletedEventArgs e)
        {
            if (e != null) this.lbPasta.ItemsSource = e.Result;                
        }

        void proxy_LlistaPostresCompleted(object sender, LlistaPostresCompletedEventArgs e)
        {
            if (e != null)  this.lbPostres.ItemsSource = e.Result;                 
        }
         #endregion

        #region Gestors d'esdeveniments de selecció de comandes dels menús.
        private void lbBegudes_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            AfegirConsumicionsSeccio(this.lbBegudes);          
        }

        private void lbInfusions_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            AfegirConsumicionsSeccio(this.lbInfusions);
        }

        private void lbEntrants_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            AfegirConsumicionsSeccio(this.lbEntrants);            
        }

        private void lbAmanides_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            AfegirConsumicionsSeccio(this.lbAmanides);
        }

        private void lbPasta_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            AfegirConsumicionsSeccio(this.lbPasta);        
        }

        private void lbCarns_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            AfegirConsumicionsSeccio(this.lbCarns);          
        }

        private void lbPeixos_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            AfegirConsumicionsSeccio(this.lbPeixos);        
        }

        private void lbPostres_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
           AfegirConsumicionsSeccio(this.lbPostres);
        }
        #endregion

        // Mètode auxiliar que permet afegir una comanda seleccionada d'un listbox d'una secció.
        private void AfegirConsumicionsSeccio(ListBox listbox)
        {
            try
            {
                if (listbox.SelectedIndex != -1)
                {
                    string seleccio = ((Consumicions)listbox.SelectedItem).nomConsumicioCatala;

                    MessageBoxResult resposta = MessageBox.Show("Vol afegir " + seleccio + "?", "Atenció!!", MessageBoxButton.OKCancel);

                    if (resposta == MessageBoxResult.OK)
                    {
                        ServiceReference.ServiceClient proxy = new ServiceReference.ServiceClient();
                        proxy.GuardarConsumicioComandaAsync(comanda.taula, seleccio);
                    }

                    listbox.SelectedIndex = -1;
                }
            }
            catch (FormatException ex) { MessageBox.Show(ex.Message, "Atenció!!", MessageBoxButton.OK); }
        }

        private void botoTornarPlats_Click(object sender, RoutedEventArgs e)
        {
            App.Current.RootVisual = new AnotarComanda(comanda);
        }

        void proxy_GuardarConsumicioComandaCompleted(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
        }
    }
}
