﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Dades;
using System.Windows.Forms;

namespace Negoci
{
    // Classe que agrupa la lògica de l'aplicació relativa a les operacions amb consumicions.
    public class Consumicio
    {
        // Establim la connexió amb les classes que modelitzen la BD.
        DataClassesDataContext db = new DataClassesDataContext();

        // Mètode que retorna les consumicions d'una secció determinada.
        public List<Consumicions> LlistaPlatsSeccio(string seccio)
        {
            try
            {
                    var query = (from p in db.Consumicions
                               where p.nomSeccio.Equals(seccio)
                               orderby p.nomConsumicioCatala, p.nomConsumicioCatala ascending
                               select p).ToList();

                    return query;
             }
             catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); return null; }         
        }

        // Mètode que retorna les consumicions d'una secció d'un menú.
        public List<Consumicio_Seccio_Menu> LlistaPlatsMenu(string menu, string seccio)
        {           
             try
             {
                    string nomMenu;

                    //  Si el menu demanat és del tipus menú del dia, buscarem a la BD el menú amb el nom del dia d'avui
                    if (menu.Equals("Dia"))
                    {
                        DateTime avui = DateTime.Today;
                        nomMenu = avui.DayOfWeek.ToString();
                    }

                    // Si es demana un menú ordinari es cercarà pel seu nom
                    else nomMenu = menu;

                    var query = (from p in db.Consumicio_Seccio_Menu
                                 where p.nomMenu.Equals(nomMenu) && p.nomSeccio.Equals(seccio)                               
                                 select p).ToList();

                    return query;
              }
              catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); return null; }          
        }
    }
}
