﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using CanVictorWeb;
using CanVictorWeb.Account;

namespace CanVictorWeb.Account
{
    public partial class Login : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {           
            RegisterHyperLink.NavigateUrl = "Registre.aspx?ReturnUrl=";            
        }

        // Mètode que gestiona l'esdeveniment produït en clicar el botó de Començar sessió
        protected void LoginButton_Click(object sender, EventArgs e)
        {
            try
            {
                CanVictorWeb.ServiceReference.ServiceClient proxy = new CanVictorWeb.ServiceReference.ServiceClient();
                // Mirem si l'usuari és un client registrat
                bool esClient = proxy.ValidarAccesClient(LoginUser.UserName, LoginUser.Password);

                // Mirem si l'usuari és un cuiner
                bool esCuiner = proxy.ValidarAccesCuiner(LoginUser.UserName, LoginUser.Password);

                // Mirem si l'usuari ha marcat la casella de "Vull seguir connectat"
                bool isPersistent = this.LoginUser.RememberMeSet;

                // Si no existeixen creem els rols.
                if (!Roles.RoleExists("Cuiners")) Roles.CreateRole("Cuiners");
                if (!Roles.RoleExists("Clients")) Roles.CreateRole("Clients");

                // Si l'usuari és un client, s'autentica el client, s'afegeix al rol i es navega a la pàgina corresponent.
                if (esClient)
                {
                    FormsAuthentication.RedirectFromLoginPage(LoginUser.UserName, isPersistent);
                    
                    if (!Roles.GetUsersInRole("Clients").Contains(LoginUser.UserName))
                    {                        
                        Roles.AddUserToRole(LoginUser.UserName, "Clients");                       
                    }
                }

                // Si l'usuari és un cuiner, s'autentica el client, s'afegeix al rol i es navega a la pàgina de Comandes.
                if (esCuiner)
                {
                    FormsAuthentication.RedirectFromLoginPage(LoginUser.UserName, isPersistent);
                  
                    if (!Roles.GetUsersInRole("Cuiners").Contains(LoginUser.UserName))
                    {
                        Roles.AddUserToRole(LoginUser.UserName, "Cuiners");                       
                    }
                                        
                    Response.Redirect("/Comandes/Comandes.aspx");                   
                }
            }
            catch (Exception) { ; }            
        }     
    }
}
