﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Dades;


namespace CanVictorWeb.Reserves
{
    public partial class Reserves : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                CanVictorWeb.ServiceReference.ServiceClient proxy = new CanVictorWeb.ServiceReference.ServiceClient();
                int id2 = int.Parse(this.User.Identity.Name);
                string id = this.User.Identity.Name.ToString();
                this.TextBox1.Text = id2.ToString();

                if (proxy.ReservesClient(id) != null)
                {

                }
                Client_Registrat client = proxy.ConsultarClient(id);

                string identificador = this.Session.SessionID.ToString();

                this.Nom.Text = client.nom;
                this.Cognom1.Text = client.cognom1;
                this.Cognom2.Text = client.cognom2;
                this.Telefon.Text = client.telefon.ToString();
                this.Correu.Text = client.email;
            }
            catch (Exception) { }
        }

        protected void CreateReservaButton_Click(object sender, EventArgs e)
        {
            try
            {
                CanVictorWeb.ServiceReference.ServiceClient proxy = new CanVictorWeb.ServiceReference.ServiceClient();

                string resultat;

                resultat = proxy.AfegirReserva(this.User.Identity.Name.ToString(), DateTime.Parse(Date.Text), TimeSpan.Parse(DropDownList1.SelectedValue.ToString()),
                    int.Parse(Comensals.Text), Comentaris.Text);

                this.GridView1.DataBind();

                // Netegem els camps de la reserva
                Date.Text = "";
                DropDownList1.SelectedIndex = -1;
                Comensals.Text = "";

                this.MissatgesReserves.Text = resultat;
            }
            catch (Exception) { }
        }

        protected void Calendar1_SelectionChanged(object sender, EventArgs e)
        {
            Date.Text = Calendar1.SelectedDate.ToShortDateString();
        }

        protected void ReservesFetes_Selecting(object sender, SqlDataSourceSelectingEventArgs e)
        {

        }

        protected void HiddenField1_ValueChanged(object sender, EventArgs e)
        {

        }

        protected void GridView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                CanVictorWeb.ServiceReference.ServiceClient proxy = new CanVictorWeb.ServiceReference.ServiceClient();
                Dades.Reserves consulta = proxy.GetReserva(int.Parse(this.GridView1.SelectedValue.ToString()));
                if (consulta != null)
                {
                    this.Date.Text = consulta.data.ToString();
                    this.DropDownList1.SelectedValue = consulta.hora.ToString();
                    this.Comensals.Text = consulta.numComensals.ToString();
                    this.Comentaris.Text = consulta.comentaris;
                }
            }
            catch (Exception) { }
        }

        // Mètode que gestiona l'esdeveniment produït en clicar el botó de "modificar"
        protected void botoModificar_Click(object sender, EventArgs e)
        {
            try
            {
                CanVictorWeb.ServiceReference.ServiceClient proxy = new CanVictorWeb.ServiceReference.ServiceClient();
                
                // Esborrem la reserva obtenint el resultat de l'operació.
                Boolean resultatEsborrar = proxy.EsborrarReserva(int.Parse(this.GridView1.SelectedValue.ToString()));

                // Afegim una nova reserva obtenint el missatge resultat.
                string resultatAfegir = proxy.AfegirReserva(this.User.Identity.Name.ToString(), DateTime.Parse(Date.Text),
                    TimeSpan.Parse(DropDownList1.SelectedValue.ToString()), int.Parse(Comensals.Text), Comentaris.Text);
                
                // Lliguem el gridview amb l'origen de dades perquè mostri els canvis tan bon punt es produeixin.
                this.GridView1.DataBind();

                // Informem l'usuari del resultat.
                this.MissatgesReserves.Text = resultatAfegir;
            }
            catch (Exception) { }
        }

        // Mètode que gestiona l'esdeveniment produït en clicar el botó de "Cancel·lar reserva"
        protected void botoCanc_Click(object sender, EventArgs e)
        {
            try
            {
                CanVictorWeb.ServiceReference.ServiceClient proxy = new CanVictorWeb.ServiceReference.ServiceClient();

                // Esborrem la reserva obtenint el resultat de l'operació.
                Boolean resultat = proxy.EsborrarReserva(int.Parse(this.GridView1.SelectedValue.ToString()));

                // Lliguem el gridview amb l'origen de dades perquè mostri els canvis tan bon punt es produeixin.
                this.GridView1.DataBind();

                // Si no s'ha esborrat la reserva
                if (resultat == false)
                {
                    this.MissatgesReserves.Text = "No s'ha pogut esborrar la Reserva";
                }

                // Si s'ha pogut esborrar
                else
                {
                    this.MissatgesReserves.Text = "S'ha esborrat la Reserva";
                }
            }
            catch (Exception) { }
         }
    }
}