﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Dades;
using System.Windows.Forms;

namespace Negoci
{
    // Classe que agrupa la lògica de l'aplicació relativa a les operacions amb clients.
    public class Client
    {
        // Establim la connexió amb les classes que modelitzen la BD.
        DataClassesDataContext db = new DataClassesDataContext();

        // Mètode que permet registrar un nou client al sistema.
        public void RegistrarClient(string DNI, string nom, string cognom1, string cognom2, string telefon, string correu, string password)
        {
            try
            {
                Client_Registrat c = new Client_Registrat();

                c.DNI = int.Parse(DNI);
                c.nom = nom;
                c.cognom1 = cognom1;
                c.cognom2 = cognom2;
                c.telefon = int.Parse(telefon);
                c.email = correu;
                c.contrasenya = password;

                // Inserim el nou client.
                db.Client_Registrat.InsertOnSubmit(c);

                // Fem els canvis.
                db.SubmitChanges();

                // Tanquem la connexió.
                db.Connection.Close();
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }            
        }

        // Mètode que retorna el client amb el DNI donat.
        public Client_Registrat ConsultarClient(string DNI)
        {
            try
            {
            Client_Registrat c = new Client_Registrat();
           
                var query = (from q in db.Client_Registrat
                            where q.DNI.Equals(DNI)
                            select q).FirstOrDefault();
                return query;
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); return null; }
        }
    }
}
